//css_ref ..\..\..\WixSharp\Output\WixSharp.dll;
using IO=System.IO;
using System;
using WixSharp;

class Script
{
    [STAThread] 
    static public void Main(string[] args)
    {
        string pluginFile = IO.Path.GetFullPath(@"Plugins\CSScriptIntellisense.dll");
        Version version = System.Reflection.Assembly.ReflectionOnlyLoadFrom(pluginFile).GetName().Version;
        
        Compiler.WixLocation = @"..\..\..\WixSharp\Main\WixSharp.Samples\Wix_bin\bin";
        
        Project project =
            new Project("C# Intellisense for Notepad++",
                new Dir(@"%ProgramFiles%\Notepad++\Plugins",
                    new File(@"Plugins\CSScriptIntellisense.dll"),
                    new Dir("CSharpIntellisense",
                        new File(@"Plugins\CSharpIntellisense\CSScriptLibrary.dll"),
                        new File(@"Plugins\CSharpIntellisense\Mono.Cecil.dll"),
                        new File(@"Plugins\CSharpIntellisense\ICSharpCode.NRefactory.CSharp.dll"),
                        new File(@"Plugins\CSharpIntellisense\ICSharpCode.NRefactory.dll"))));

        project.GUID = new Guid("6f930b47-2277-435d-9095-1861ba25889b");
        
        project.Version = version;
        project.MajorUpgradeStrategy = MajorUpgradeStrategy.Default;
        project.LicenceFile = "license.rtf";

        Compiler.BuildMsi(project, "CSScriptIntellisesne.msi");
    }
}